<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

define( 'COMMENTS_ADMIN_CONTROLER_PATH', dirname( __FILE__ ) );

class JControler_tc_comments_blacklist extends JObject
{
	var $command		= null;
	var $db				= null;

	var $filter			= null;
	var	$limit			= null;
	var $limitstart		= null;

	var $html			= null;
	var $model			= null;
	

	function __construct( &$command )
	{	
		parent::__construct();
		$this->command 	= $command;
		$this->db		=& JFactory::getDBO();
		$this->error	=& new JError();

		$this->model 	= new JModel_comments_blacklist( $this->db ); 
		$this->html 	= new JHTML_tc_comments_blacklist( $this->command );

	}
	
	
	/**
	*	tc_comments_blacklist::_new
	*
	*/
	function _new()
	{
		$this->_edit( 0 );
	}
	
	
	
	/**
	*	JControler_tc_comments_blacklist::_store
	*
	*/
	function _store()
	{
		global $mainframe;
		
		$this->model->save();
		
		switch ( $this->command->get('task') )
		{
			case 'apply':
				$msg = sprintf(JText::_('Successfully Applied change to item') );
				$link = "index2.php?option={$this->command->option}&c=blacklist&task=edit&cid[]={$this->model->get('id')}";
			break;
		
			case 'save':
			default:
				$msg = sprintf(JText::_('Successfully Saved changes to Item') );
				$link = "index2.php?option={$this->command->get('option')}&c=blacklist";
			break;
		}
		
		$mainframe->redirect( $link, $msg );
	}
	
	
	
	/**
	*	JControler_tc_comments_blacklist::_remove
	*	@param int
	*/
	function _remove( $cid = Array() )
	{
		global $mainframe;
		
      error_log("attempt to remove $cid[0]");
		$this->model->delete( $cid );
		$redirect = "index2.php?option={$this->command->get('option')}&c=blacklist&task=list";
		$mainframe->redirect( $redirect );
	}
	
	
	
	/**
	*	JControler_tc_comments_blacklist::_cancel
	*
	*/
	function _cancel()
	{
		global $mainframe;
		
		$this->model->bind( $_POST );
		$this->model->checkin();	
		$redirect = ampReplace("index2.php?option={$this->command->get('option')}");
		$mainframe->redirect( $redirect );
	}
	
	
	
	/**
	*	JControler_tc_comments_blacklist::_change_publish_state
	*/
	function _change_publish_state( $cid = array(), $state = 0 )
	{
		global $mainframe;
		
		$this->model->publish( $cid, $state );
		$redirect = "index2.php?option={$this->command->get('option')}&c=blacklist";
		$mainframe->redirect( $redirect );
	}
	
	/**
	*	JControler_tc_comments_blacklist::_list
	*/
	function _list( )
	{
		global $mainframe;

		$this->html 	= new JHTML_tc_comments_blacklist( $this->command );

      $filter_order = JRequest::getVar( 'filter_order', 'id' );
      $filter_order_Dir = JRequest::getVar( 'filter_order_Dir', 'asc' );
		if( $filter_order )
			$orderby = "\n ORDER BY $filter_order $filter_order_Dir ";
		else
			$orderby = "\n ORDER BY id ";
      $limit          = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
      $limitstart     = $mainframe->getUserStateFromRequest( $context.'limitstart', 'limitstart', 0, 'int' );

		jimport('joomla.html.pagination');
                // get the total number of records
      $query = 'SELECT COUNT(*) as c  FROM #__k2_comments_blacklist';

      $this->db->setQuery( $query );
      $this->db->query();
		$row = $this->db->loadObject();
      $total = $row->c;

		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT * "
		."\n FROM #__k2_comments_blacklist AS a "
//		."\n $where "
		."\n $orderby "
		."\n LIMIT ".$pageNav->get('limitstart').", ".$pageNav->get('limit')
		;

      error_log($query);
		$this->db->setQuery( $query );
		$rows = $this->db->loadObjectList();
		
//		$this->html->ui_element['filter'] = $filter;
		
		// state filter 
//		$lists['state'] = mosCommonHTML::selectState( $filter_state );

   	$this->html->ui_element['order_Dir'] = $filter_order_Dir;

		$this->html->ui_element['order'] = $filter_order;
		
		$this->html->_list( $rows, $pageNav );
	}

}
?>
