<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

define( 'COMMENTS_ADMIN_CONTROLER_PATH', dirname( __FILE__ ) );

class JControler_tc_comments extends JObject
{
	var $command		= null;
	var $db				= null;

	var $filter			= null;
	var	$limit			= null;
	var $limitstart		= null;

	var $html			= null;
	var $model			= null;
	

	function __construct( &$command )
	{	
		parent::__construct();
		$this->command 	= $command;
		$this->db		=& JFactory::getDBO();
		$this->error	=& new JError();

		$this->model 	= new JModel_comments_reported( $this->db ); 
		
	}
	
	
	/**
	*	JControler_tc_comments::_store
	*
	*/
	function _store()
	{
		global $mainframe;
		
	   $action = JRequest::getVar('action', array(0), 'post', 'array');
      foreach ($action as $comment => $this_action)
      {
         error_log("comment=$comment this_action=$this_action");
         $query = "";
         switch ($this_action)
         {
            case 'approve':
               $query = "DELETE FROM #__k2_comments_reported WHERE comment = " . $comment;
               error_log($query);
               $this->db->setQuery( $query );
               $this->db->query();
               $query = "UPDATE #__k2_comments SET approved = true WHERE id = " . $comment;
               break;
            case 'blacklist':
               $query = "SELECT ip FROM #__k2_comments WHERE id = " . $comment; 
               $this->db->setQuery( $query );
               $ip = $db->loadResult();
               $query = "INSERT INTO #__k2_comments_blacklist (ip) VALUES ('" . $ip . "')";
               $this->db->setQuery( $query );
               $this->db->query();
               
            case 'delete':   
               $query = "DELETE FROM #__k2_comments_votes WHERE comment = " . $comment;
               $this->db->setQuery( $query );
               $this->db->query();
               $query = "DELETE FROM #__k2_comments_reported WHERE comment = " . $comment;
               $this->db->setQuery( $query );
               $this->db->query();
               $query = "DELETE FROM #__k2_comments WHERE id = " . $comment;
               break;
         }
         if (strlen($query))
         {
            $this->db->setQuery( $query );
            $this->db->query();
         }
      }

		
		switch ( $this->command->get('task') )
		{
			case 'apply':
				$msg = sprintf(JText::_('Successfully Applied changes to Item') );
				$link = "index2.php?option={$this->command->option}&c=tc_comments&task=comments";
			break;
		
			case 'save':
			default:
				$msg = sprintf(JText::_('Successfully Saved changes to Item') );
				$link = "index2.php?option={$this->command->get('option')}&c=tc_comments";
			break;
		}
		
		$mainframe->redirect( $link, $msg );
	}
	
	
	
	/**
	*	JControler_tc_comments::_remove
	*	@param int
	*/
	function _remove( $cid = Array() )
	{
		global $mainframe;
		
      error_log("attempt to remove $cid[0]");
		$this->model->delete( $cid );
		$redirect = "index2.php?option={$this->command->get('option')}&c=comments&task=list";
		$mainframe->redirect( $redirect );
	}
	
	
	
	/**
	*	JControler_tc_comments::_cancel
	*
	*/
	function _cancel()
	{
		global $mainframe;
		
		$this->model->bind( $_POST );
		$this->model->checkin();	
		$redirect = ampReplace("index2.php?option={$this->command->get('option')}");
		$mainframe->redirect( $redirect );
	}
	
	
	
	/**
	*	JControler_tc_comments::_list
	*/
	function _list( )
	{
      global $mainframe, $option;

		$this->html 	= new JHTML_tc_comments_comments( $this->command );

      $filter_order = JRequest::getVar( 'filter_order', 'id' );
      $filter_order_Dir = JRequest::getVar( 'filter_order_Dir', 'asc' );
		if( $filter_order )
			$orderby = "\n ORDER BY $filter_order $filter_order_Dir ";
		else
			$orderby = "\n ORDER BY id ";
      $limit          = $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
      $limitstart     = $mainframe->getUserStateFromRequest( $context.'limitstart', 'limitstart', 0, 'int' );

      $where = "WHERE NOT b.approved";
      
      $filter_status = $mainframe->getUserStateFromRequest( $option.'filter_status',
         'filter_status', NULL, 'string' );
      $this->html->ui_element['filter_fromdate'] = $filter_fromdate;
      $this->html->ui_element['filter_todate'] = $filter_todate;
      
      if (strlen($filter_status))
      {
         if (strlen($where))
            $where .= "AND ";
         else
            $where = "WHERE ";   
         $where .= "status = '$filter_status' ";
      }   

      if (strlen($filter_fromdate))
      {
         if (strlen($where))
            $where .= "AND ";
         else
            $where = "WHERE ";   
         $where .= "receiveddate >= '$filter_fromdate' ";
      }   

      if (strlen($filter_todate))
      {
         if (strlen($where))
            $where .= "AND ";
         else
            $where = "WHERE ";   
         $where .= "receiveddate <= '$filter_todate' ";
      }   

		jimport('joomla.html.pagination');
                // get the total number of records
      $query = 'SELECT COUNT(*) as c  FROM #__k2_comments_reported';

      $this->db->setQuery( $query );
      $this->db->query();
		$row = $this->db->loadObject();
      $total = $row->c;

		$pageNav = new JPagination( $total, $limitstart, $limit );
		
		$query = "SELECT a.*,b.commentText,b.ip,c.title"
		."\n FROM #__k2_comments_reported AS a "
		."\n LEFT JOIN #__k2_comments as b ON a.comment = b.id "
		."\n LEFT JOIN #__k2_items as c ON b.itemID = c.id "
		."\n $where "
		."\n $orderby "
		."\n LIMIT ".$pageNav->get('limitstart').", ".$pageNav->get('limit')
		;

      error_log($query);
		$this->db->setQuery( $query );
		$rows = $this->db->loadObjectList();
		
   	$this->html->ui_element['order_Dir'] = $filter_order_Dir;

		$this->html->ui_element['order'] = $filter_order;
		



		$this->html->_list( $rows, $pageNav );
	}

}

// blacklist
require( COMMENTS_ADMIN_CONTROLER_PATH.'/admin.blacklist.php' );
require( COMMENTS_ADMIN_CONTROLER_PATH.'/admin.voted.php' );

?>
