<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

define( 'COMMENTS_CLASS_PATH', dirname( __FILE__ ).'/model/' );



class JModel_comments extends JObject{
	
	var $_db 		= null;
	var $_error		= null;
	var $_entity		= null;
	var $_relations	= array();
	
	function __construct( &$db )
	{
		$this->_db 			= $db;
	}
	
	/**
	 * Returns the error message
	 *
	 * @return string
	 */
	function getError() {
		return $this->_entity->getError();
	}
	
	
	
	/**
	 * JModel_comments::bind
	 *
	 */
	function bind( $array = null )
	{
		return $this->_entity->bind($array);
	}
	
	
	
	/**
	 * JModel_comments::check
	 *
	 */
	function check()
	{
		return $this->_entity->check();
	}
	
	
	
	/**
	 * 	JModel_comments::load
	 * 
	 */
	 function load( $key = 0 )
	 {
	 	return $this->_entity->load( $key );
	 }
	 
	 
	 
	 /**
	 * JModel_comments::store
	 * 
	 */
	function store()
	{
		$x = $this->_entity->store();
		if ($this->_entity->_db->_errorNum)
		{
         ob_start();
         var_dump($this->_entity);
         error_log(ob_get_contents());
         ob_end_clean();
         JError::raiseError($this->_entity->_db->_errorNum, $this->_entity->_db->_errorMsg);
      }   
		return($x);	
	}
	  
	  
	/**
	 * JModel_comments::checkout
	 * 
	 */
	function checkout( $who, $oid=null )
	{
		return $this->_entity->checkout( $who, $oid );
	}


	
	/**
	 * JModel_comments::checkin
	 * 
	 */	
	function checkin( $oid=null )
	{
		return $this->_entity->checkin($oid );
	}
	
	
	
	/**
	 * JModel_comments::reorder
	 * 
	 */
	function reorder( $where='' )
	{
		return $this->_entity->reorder($where);
	}
	
	
	
	/**
	 * JModel_comments::move
	 * 
	 */
	function move( $dirn = 0, $where = null )
	{
		$this->_entity->move( $dirn, $where );
	}
	
	
	
	/**
	 * JModel_comments::get
	 * 
	 */
	 function get( $attr )
	 {
		return $this->_entity->get( $attr );
	 }
	 
	 
	 
	 /**
	  * JModel_comments::set
	  * 
	  */
	 function set( $attr, $value )
	 {
		return $this->_entity->set( $attr, $value );
	 }
	 
	 
	 /**
	  * JModel_comments::get_entity
	  * 
	  */
	  function get_entity()
	  {
	  	return $this->_entity;
	  }
	  
	  
	  
	  /**
	   * JModel_comments::publish
	   * 
	   */
	   function publish( $cid=null, $publish=1, $user_id=0 )
	   {		
	   		return $this->_entity->publish( $cid, $publish, $user_id  );
	   }
	   
	   
	   
	   /**
	    * JModel_comments::delete
	    * 
	    */
	    function delete($id='')
	    {
	    		return $this->_entity->delete( $id );
	    }
	    
	    
    
	
}



/**
 * 
 * 
 */
class JTable_comments extends JTable {


	/**
	 * 
	 * 
	 */
	 function load($id=0)
	 {
	 	if(parent::load( $id )){
	 		return true;	
	 	}
	 	return false;
	 }


	/**
	 * 	JTable_comments::_load_attribute
	 * 
	 */
	function load_attribute( $attr = null, $key = 0 )
	{
		if( $this->$attr )
			return false;
		
		$query = "SELECT $attr"
		. "\n FROM $this->_tbl"
		. "\n WHERE $this->_tbl_key = '$key' "
		;		
		$this->_db->setQuery( $query );
		$this->$attr = $this->_db->loadResult();
		
		return true;
	}
	
	
	
	/**
	 *	JTable_comments::publish
	 * 
	 */
	function publish( $cid=null, $publish=1, $user_id=0 )
	{
		global $mainframe;
		
		$publishe = intval( $publish );
		$cid = implode(', ', $cid );
		
		if( $cid )
		{
			$query = "UPDATE ".$this->_tbl
			."\n SET published = ".$publish
			."\n WHERE ".$this->_tbl_key." IN ( $cid ) "
			;
			$this->_db->setQuery( $query );
			$this->_db->query();
		}
		
	}


// end class JTable_comments_messages
}

// comments_reported
require( COMMENTS_CLASS_PATH.'comments_reported.class.php' );
require( COMMENTS_CLASS_PATH.'comments_blacklist.class.php' );
require( COMMENTS_CLASS_PATH.'comments_votes.class.php' );


?>
